<?php
  /**
   * Automatic Image Upload with Thumbnails - uploadimg_post.php
   * 
   * @author : Koos
   * @post integration version 1.0.2
   * @gallery release date : 2013-11-06
   */

define('PUN_ROOT', './');
require PUN_ROOT.'include/common.php';
require PUN_ROOT.'uploadimg_config.php';
// Retrieving style folder
//require PUN_ROOT.'plugins/ezbbc/config.php';

// --- Config start ---
$ezbbc_config = array (
'img_list' => 'img_list', // [no_img_list / img_list] change to "img_list" to allow the user to see a list of his/her uploaded images
'img_upload' => 'img_upload', // if not set to "img_upload", the image upload feature will be disabled
'resize_width' => '800', // default = 640
'resize_height' => '600', // default = 480
'rename_duplicates' => 'no', // if yes, a number will be added to end of filename if file already exists (e.g. if uploading filename.jpg, and it already exists, it will be automatically renamed to filename(1).jpg)
//'max_img_width' => 300, // [koos: not used anymore]
);
// --- Config end ---


// Rebuild permissions array
for($y = 0; $y < count($Allow_Uploads); $y++)
{
	$perm_parts = explode('-', $Allow_Uploads[$y]);
	$Allow_Uploads[$y] = $perm_parts[0];

	if ($pun_user['g_title'] == $Allow_Uploads[$y])
		$usage_max = $perm_parts[1]*1024;
}

// Determine usage start
$result = $db->query('SELECT upload_usage FROM '.$db->prefix.'users WHERE id='.$pun_user['id'].'') or error('Unable to fetch upload usage', __FILE__, __LINE__, $db->error());
$user_data = $db->fetch_assoc($result);
$upload_usage = $user_data['upload_usage']/1024;

if (!empty($usage_max))
	$usage_perc = round(((($upload_usage / $usage_max)*100)),0);
else
	$usage_perc = 0;
// Determine usage end

//$allowed_ext = array('jpg', 'gif', 'png', 'jpeg'); // [koos: not used anymore]
$location = PUN_ROOT.$idir; // [koos edit]
$location_thumbs = PUN_ROOT.$tdir; // [koos edit]
$path = $pun_config['o_base_url'].'/'.$idir; // [koos edit]
$file_path = '';
$upload_ok = false;
$message ='';
$action_message = '';
$img_list = array();
$loc_user_folder = $location; // [koos edit]

// [koos edit]
$file_prefix = $pun_user['id'].'_'; // the pun user id is used as the prefix for all uploaded files
$absolute_path_images = dirname(__FILE__) . "/" . substr_replace($idir,"",-1);
$absolute_path_thumbs = dirname(__FILE__) . "/" . substr_replace($tdir,"",-1); 

// Getting the textarea name from get string
$textarea_name = isset($_GET['textarea_name']) && $_GET['textarea_name'] == 'req_message' ? 'req_message' : 'signature';
// Language file load
require PUN_ROOT.'lang/'.$pun_user['language'].'/common.php';
require PUN_ROOT.'lang/'.$pun_user['language'].'/uploadimg.php';
require PUN_ROOT.'lang/'.$pun_user['language'].'/uploadimg_post.php';

if ($ezbbc_config['img_upload'] == 'img_upload' && !$pun_user['is_guest'])
{
	// If action required 
	if (isset($_GET['action']))
	{
		$action = $_GET['action'];
		$filename = pun_htmlspecialchars($_GET['fname']);
		if (1)
		{
			$timestamp = $matches[1];
			$name = $matches[2];
			$ext = $matches[3];
			$name = $name.'.'.$ext;
			$rootfolder = $idir; // [koos edit]
			$file_path = PUN_ROOT.$rootfolder.$filename;
			$file_path_thumbs = PUN_ROOT.$tdir.$filename; // [koos edit]
			if ($action == 'remove')
			{
				$deletethis = $filename;
				$partsf = Explode('_', $deletethis);
				$dienr = $partsf[0];

				// get file size of image (not the thumb)
				$upload_usage_del = @filesize("$absolute_path_images/$deletethis");
				$upload_count_del = 1;

				if (!($dienr == $pun_user['id'] && in_array($pun_user['g_title'], $Allow_Delete)))
				{
					$action_message = '<p id="amessage" style="color: red; text-align: center;">'.$lang_uploadimg_post['No delete permission'].'</p>';
				}
				else if (@unlink($file_path))
				{
					// Update 'upload usage' and 'upload count'
					$db->query('UPDATE '.$db->prefix.'users SET upload_usage=upload_usage-'.intval($upload_usage_del).', upload_count=upload_count-'.$upload_count_del.' WHERE id='.intval($dienr)) or error('Unable to update upload usage', __FILE__, __LINE__, $db->error());

					// Delete database entry
					$db->query('DELETE FROM '.$db->prefix.'uploadimg WHERE filename=\''.$db->escape($deletethis).'\'') or error('Unable to delete image info', __FILE__, __LINE__, $db->error());

					@unlink($file_path_thumbs); //delete the thumb also

					$action_message = '<p id="amessage" style="color: green; text-align: center;">/'.$rootfolder.$filename.' '.$lang_uploadimg_post['File delete ok'].'</p>';
				}
				else
				{
					$action_message = '<p id="amessage" style="color: red; text-align: center;">/'.$rootfolder.$filename.' '.$lang_uploadimg_post['File delete fail'].'</p>';
				}
			}
		}
	}
	// End action required


	//
	// Get file extension
	//
	function GetExt($val)
	{
		$val = strtolower($val);

		switch($val)
		{
			case "gif";
				$type = "GIF";
				break;
			case "jpg";
				$type = "JPEG";
				break;
			case "jpeg";
				$type = "JPEG";
				break;
			case "png";
				$type = "PNG";
				break;
		
			default:
				$type = "";
		}
	
		return $type;
	}


	//
	// Image resize function
	//
	function imageThumb($originalImage, $toWidth, $toHeight, $width, $height)
	{
		global $type;

		if ($width < $toWidth && $height < $toHeight)
		{
			$xscale = 1;
			$yscale = 1;
		}
		else
		{
			$xscale = $width/$toWidth;
			$yscale = $height/$toHeight;
		}

		// Recalculate new size with default ratio
		if ($yscale>$xscale)
		{
			$new_width = round($width * (1/$yscale));
			$new_height = round($height * (1/$yscale));
		}
		else
		{
			$new_width = round($width * (1/$xscale));
			$new_height = round($height * (1/$xscale));
		}

		$image_resized = imagecreatetruecolor($new_width, $new_height);

		if ($type == 1 || $type == 3)
		{
			$trnprt_indx = imagecolortransparent($originalImage);

			// If we have a specific transparent color
			if ($trnprt_indx >= 0)
			{
				// Get the original image's transparent color's RGB values
				$trnprt_color = imagecolorsforindex($originalImage, $trnprt_indx);

				// Allocate the same color in the new image resource
				$trnprt_indx = imagecolorallocate($image_resized, $trnprt_color['red'], $trnprt_color['green'], $trnprt_color['blue']);

				// Completely fill the background of the new image with allocated color
				imagefill($image_resized, 0, 0, $trnprt_indx);

				// Set the background color for new image to transparent
				imagecolortransparent($image_resized, $trnprt_indx);
			}
			// Always make a transparent background color for PNGs that don't have one allocated already
			elseif ($type == 3)
			{
				// Turn off transparency blending (temporarily)
				imagealphablending($image_resized, false);

				// Create a new transparent color for image
				$color = imagecolorallocatealpha($image_resized, 0, 0, 0, 127);

				// Completely fill the background of the new image with allocated color.
				imagefill($image_resized, 0, 0, $color);

				// Restore transparency blending
				imagesavealpha($image_resized, true);
			}
		}

		imagecopyresampled($image_resized, $originalImage, 0, 0, 0, 0, $new_width, $new_height, $width, $height);

		return $image_resized;
	}


	//
	// Check if word starts with a particular prefix
	//
	function prefix($word, $prefix)
	{
			if (strlen($word) < strlen($prefix))
			{
				$tmp = $prefix;
				$prefix = $word;
				$word = $tmp;
			}

			$word = substr($word, 0, strlen($prefix));

			if ($prefix == $word)
			{
					return 1;
			}

			return 0;
	}


	//
	// Function to get the extension of a file
	//
	function strip_ext($name)
	{
		$ext = strrchr($name, '.');

		if ($ext !== false)
			$name = substr($name, 0, -strlen($ext));

		return $name;
	}
	

	//
	// Check whether a file/folder is writable
	// This function also works on Windows Server where ACLs seem to be ignored
	//
	function uploadimg_forum_is_writable($path)
	{
		if (is_dir($path))
		{
			$path = rtrim($path, '/').'/';
			return uploadimg_forum_is_writable($path.uniqid(mt_rand()).'.tmp');
		}
	
		// Check temporary file for read/write capabilities
		$rm = file_exists($path);
		$f = @fopen($path, 'a');
	
		if ($f === false)
			return false;
	
		fclose($f);
	
		if (!$rm)
			@unlink($path);
	
		return true;
	}


	//Function to get the max_file_size in the php.ini file
	function return_bytes($FormattedSize)
	{
		$FormattedSize = trim($FormattedSize);
		$Size = floatval($FormattedSize);
		$MultipSize = strtoupper(substr($FormattedSize, -1));

		if ($MultipSize == "G") $Size *= pow(1024, 3);
		else if ($MultipSize == "M") $Size *= pow(1024, 2);
		else if ($MultipSize == "K") $Size *= 1024;

		return $Size;
	}

	$max_file_size_php = return_bytes(ini_get('upload_max_filesize'));

	// Counting the already uploaded images
	$img_count = 0;
	$img_list = array();
	$img_list_dates = array();
/*
	$img_file_prefix = $file_prefix;
	if ($handle = opendir($idir))
	{
		while (($img_file = readdir($handle)) !== false)
		{
			if (!in_array($img_file, array('.', '..')) && !is_dir($idir.$img_file) && prefix($img_file, $img_file_prefix))
			{
				$file_ext = pathinfo($img_file, PATHINFO_EXTENSION);
				if (!in_array($file_ext,$allowed_ext)) { continue; }
				$img_list[] = $img_file;
			}
		}
		rsort($img_list);
		$img_count = count($img_list);
	}
*/

	// Fetch user's images
	$result = $db->query('SELECT * FROM '.$db->prefix.'uploadimg WHERE user_id='.$pun_user['id'].' AND type!=\'\' ORDER by date DESC') or error('Unable to fetch images info', __FILE__, __LINE__, $db->error());
	// If there are results
	if ($db->num_rows($result))
	{
		while ($cur_image = $db->fetch_assoc($result))
		{
			$img_list[] = $cur_image['filename'];
			$img_list_dates[$cur_image['filename']] = $cur_image['date'];
		}

		$img_count = count($img_list);
	}



		// Setting max values
		$ezbbc_max_img_size = $max_file_size_php / 1024;

		// File submission
		if (isset($_POST['subfile']) && ($usage_perc < 100))
		{
			$file_name = $_FILES['file']['name'];
			$uploaded_file = $_FILES['file']['tmp_name'];

			//User folder treatment
			$location = $loc_user_folder;

			if (uploadimg_forum_is_writable($location) && uploadimg_forum_is_writable($location_thumbs))
			{
				//---treating the file name start---
				$file_name_rl = strip_ext($file_name);
				$file_name_ext = strtolower(end(explode('.',$file_name))); // get the file extension

				// Transliterate all characters with accents,umlauts,ligatures and runes known to ISO-8859-1
				$file_name_rl = strtr($file_name_rl,"\xA1\xAA\xBA\xBF\xC0\xC1\xC2\xC3\xC5\xC7\xC8\xC9\xCA\xCB\xCC\xCD\xCE\xCF\xD0\xD1\xD2\xD3\xD4\xD5\xD8\xD9\xDA\xDB\xDD\xE0\xE1\xE2\xE3\xE5\xE7\xE8\xE9\xEA\xEB\xEC\xED\xEE\xEF\xF0\xF1\xF2\xF3\xF4\xF5\xF8\xF9\xFA\xFB\xFD\xFF","!ao?AAAAACEEEEIIIIDNOOOOOUUUYaaaaaceeeeiiiidnooooouuuyy");
				$file_name_rl = strtr($file_name_rl, array("\xC4"=>"Ae", "\xC6"=>"AE", "\xD6"=>"Oe", "\xDC"=>"Ue", "\xDE"=>"TH", "\xDF"=>"ss", "\xE4"=>"ae", "\xE6"=>"ae", "\xF6"=>"oe", "\xFC"=>"ue", "\xFE"=>"th"));

				// Strip all non-alphanumeric characters (except _ -) from string and replace all spaces with _ (underscore)
				$find = array("/[^a-zA-Z0-9\-\_\s]/","/\s+/");
				$replace = array("","_");
				$file_name_rl = strtolower(preg_replace($find,$replace,$file_name_rl));

				// Truncate filename if longer than 100 characters
				$file_name_rl = (strlen($file_name_rl) > 100) ? substr($file_name_rl, 0 , 100) : $file_name_rl;
				
				$file_name = $file_name_rl.".".$file_name_ext;
				//---treating the file name end---


				// Add number at end if the file exists
				if (trim(strtolower($ezbbc_config['rename_duplicates'])) == 'yes')
				{
					$i = 0;
					do
					{
						// Check in the file exists
						$exists = file_exists($absolute_path_images.'/'.$file_prefix.$file_name);
						if ($exists)
						{
							$i++;

							$file_name = $file_name_rl.'('.$i.')'.'.'.$file_name_ext;
						}
					}
					while ($exists);
				}


				$timestamp = time();
				//$def_file_name = $timestamp.'_'.$file_name; // [koos edit]
				$def_file_name = $file_prefix.$file_name; // [koos edit]
				$file_location = $location.$def_file_name;
				$file_path = $pun_config['o_base_url'].'/'.$idir.$def_file_name; // [koos edit]
				$file_ext = pathinfo($file_name, PATHINFO_EXTENSION);
				list($width, $height) = @getimagesize($uploaded_file);
				// Handling the errors and finally send the file to the folder
				if ($_FILES['file']['error'] == UPLOAD_ERR_NO_FILE)
				{
					$message = '<span style="color: orange"> » '.$lang_uploadimg_post['No file submitted'].'</span>';
				}
/*
				else if (!in_array($file_ext,$allowed_ext))
				{
					$message = '<span style="color: orange"> » <strong>'.$file_ext.'</strong> '.$lang_uploadimg_post['File not allowed'].'</span>';
				}
*/
				// --- Koos checks start ---

				// Check if upload limit has been reached
				else if ($usage_perc >= 100)
				{
					$message = '<span style="color: orange"> » '.$lang_uploadimg['Limit reached'].'</span>';
				}
				// Determine whether file is correct filetype
				else if (!((($_FILES['file']['type'] == "image/jpg" || $_FILES['file']['type'] == "image/jpeg" || $_FILES['file']['type'] == "image/pjpeg") && ($file_name_ext == "jpg" || $file_name_ext == "jpeg") && ($allow_jpg_uploads == "1")) || (($_FILES['file']['type'] == "image/png" || $_FILES['file']['type'] == "image/x-png") && ($file_name_ext == "png") && ($allow_png_uploads == "1")) || (($_FILES['file']['type'] == "image/gif") && ($file_name_ext == "gif") && ($allow_gif_uploads == "1"))))
				{
					$message = '<span style="color: orange"> » '.$lang_uploadimg['Wrong filetype'].$message2.'. '.$lang_uploadimg['Yours is'].' '.'<strong>'.$_FILES['file']['type'].'</strong></span>';
				}
				// Check if the file exists
				else if (file_exists($absolute_path_images.'/'.$file_prefix.$file_name))
				{
					$message = '<span style="color: orange"> » '.$lang_uploadimg['File exists'].'</span>';
				}
				// Check if file size is not too big
				else if (($size_limit == "yes") && (($limit_size*1024) < $_FILES['file']['size']))
				{
					$message = '<span style="color: orange"> » '.str_replace('<MAX_SIZE>', $limit_size, $lang_uploadimg['Too big']).'</span>';
				}
				else if ($_FILES['file']['error'] == UPLOAD_ERR_FORM_SIZE || $_FILES['file']['error'] == UPLOAD_ERR_INI_SIZE)
				{
					$message = '<span style="color: orange"> » '.$lang_uploadimg_post['File too big'].'</span>';
				}
				// Can the file be uploaded?
				else if (empty($_FILES['file']['tmp_name']))
				{
					$message = '<span style="color: orange"> » '.$lang_uploadimg['Unable to upload'].'</span>';
				}

				// --- Koos checks end ---

/*
				else if ($_FILES['file']['error'] == UPLOAD_ERR_FORM_SIZE || $_FILES['file']['error'] == UPLOAD_ERR_INI_SIZE || filesize($uploaded_file) > $ezbbc_max_img_size*1024)
				{
					$message = '<span style="color: orange"> » '.$lang_uploadimg_post['File too big'].'</span>';
				}
*/

/*
				else if ($width > $ezbbc_config['max_img_width'])
				{
					$gd = gd_info();

					if ($gd["PNG Support"] && $gd["GIF Read Support"] && ($gd["JPEG Support"] || $gd["JPG Support"]) && is_uploaded_file($uploaded_file))
					{
						//Moving the temp file to user folder (to have resizing job work in all server cases)
						$temp_file = $file_location.'.tmp';
						if (@move_uploaded_file($uploaded_file,$temp_file))
						{
							//Width too big, we have to resize the file
							$new_width = $ezbbc_config['max_img_width'];
							$new_height = $ezbbc_config['max_img_width']/$width*$height;
							switch ($file_ext)
							{
								case 'gif':
									$img_to_modify = imagecreatefromgif ($temp_file);
									$new_name = str_replace('.gif', '.jpg', $def_file_name);
									break;
								case 'png':
									$img_to_modify = imagecreatefrompng($temp_file);
									$new_name = str_replace('.png', '.jpg', $def_file_name);
									break;
								case 'jpg':
									$img_to_modify = imagecreatefromjpeg($temp_file);
									$new_name = str_replace('.jpg', '.jpg', $def_file_name);
									break;
								case 'jpeg':
									$img_to_modify = imagecreatefromjpeg($temp_file);
									$new_name = str_replace('.jpeg', '.jpg', $def_file_name);
									break;
							}
							$resized_img = imagecreatetruecolor($new_width, $new_height);
							imagecopyresampled($resized_img, $img_to_modify, 0, 0, 0, 0, $new_width, $new_height, $width, $height);
							$upload_ok = imagejpeg($resized_img,$loc_user_folder.$new_name,85 );
							@chmod($loc_user_folder.$new_name, 0644);
							imagedestroy($resized_img);
							imagedestroy($img_to_modify);
							@unlink($temp_file);
							//adding file to the uploaded img array
							array_unshift($img_list, $def_file_name);
							$img_count++;
						}
						else
						{
							$message = '<span style="color: orange"> » '.$lang_uploadimg_post['Img size too large'].$ezbbc_config['max_img_width'].'px</span>';
						}
					}
					else
					{
						$message = '<span style="color: orange"> » '.$lang_uploadimg_post['Img size too large'].$ezbbc_config['max_img_width'].'px</span>';
					}
				}
				else if (is_uploaded_file($uploaded_file) && @move_uploaded_file($uploaded_file,$file_location))
				{
					$upload_ok = true;
					//adding file to the uploaded img array
					array_unshift($img_list, $def_file_name);
					$img_count++;
				}
				else
				{
					$message = '<span style="color: orange"> » '.$lang_uploadimg_post['Upload fail'].'</span>';
				}
*/
				else
				{
//=========================================================================================
//                                   UPLOADIMG CODE START
//=========================================================================================

					// Allocate all necessary memory for the image
					ini_set('memory_limit', '-1');

					$nameoffile = $file_prefix.$file_name;

					if ($_FILES['file']['type'] == "image/jpg" || $_FILES['file']['type'] == "image/jpeg" || $_FILES['file']['type'] == "image/pjpeg")
					{
						$simg = @imagecreatefromjpeg($_FILES['file']['tmp_name']);   // Make A New Temporary Image To Create The Thumbnail From
						$type = 2;
					}
					elseif ($_FILES['file']['type'] == "image/png" || $_FILES['file']['type'] == "image/x-png")
					{
						$simg = @imagecreatefrompng($_FILES['file']['tmp_name']);   // Make A New Temporary Image To Create The Thumbnail From
						$type = 3;
					}
					elseif ($_FILES['file']['type'] == "image/gif")
					{
						$simg = @imagecreatefromgif($_FILES['file']['tmp_name']);   // Make A New Temporary Image To Create The Thumbnail From
						$type = 1;
					}

					$currwidth = @imagesx($simg);   // Current Image Width
					$currheight = @imagesy($simg);   // Current Image Height

					$dimg = imageThumb($simg, $twidth, $theight, $currwidth, $currheight);

					if ($type == 2)
					{
						@imagejpeg($dimg, "$tdir" . $nameoffile, 75);   // Saving The Image
					}
					elseif ($type == 3)
					{
						@imagepng($dimg, "$tdir" . $nameoffile);   // Saving The Image
					}
					elseif ($type == 1)
					{
						@imagegif($dimg, "$tdir" . $nameoffile);   // Saving The Image
					}
      

					// Only continue if thumb was created
					if (file_exists("$absolute_path_thumbs/$nameoffile"))
					{
						//if (($resize_images_above_limit == "yes") && ($limit_sizef < $_FILES['file']['size']))
						// Force resize of image
						if (1)
						{
							// In case resize width or height has not been set, fall back to defeault values
							if ($ezbbc_config['resize_width'] == '' || $ezbbc_config['resize_height'] == '')
							{
								$ezbbc_config['resize_width'] = '640';
								$ezbbc_config['resize_height'] = '480';
							}

							if ($currwidth > $currheight)
							{
								$jwidth = $ezbbc_config['resize_width'];   // Maximum Width For Resized Images
								$jheight = $ezbbc_config['resize_height'];   // Maximum Height For Resized Images
							}
							else
							{
								$jwidth = $ezbbc_config['resize_height'];   // Maximum Width For Resized Images
								$jheight = $ezbbc_config['resize_width'];   // Maximum Height For Resized Images
							}   
						}

						//============= RESIZE IMAGE CODE START =============
						if (isset($jwidth)) 
						{
							$jdimg = imageThumb($simg, $jwidth, $jheight, $currwidth, $currheight);
					
							if ($type == 2)
							{
								@imagejpeg($jdimg, "$idir" . $nameoffile, 75);   // Saving The Image
							}
					
							elseif ($type == 3)
							{
								//if ($gd_flag != "1")
								//	@imagetruecolortopalette($jdimg, true, 256);  // convert to 256 colors
					
								@imagepng($jdimg, "$idir" . $nameoffile);   // Saving The Image
							}
						
							elseif ($type == 1)
							{
								//if ($gd_flag != "1")
								//	@imagetruecolortopalette($jdimg, true, 256);  // convert to 256 colors
					
								@imagegif($jdimg, "$idir" . $nameoffile);   // Saving The Image
							}

							imagedestroy($jdimg);   // Destroying The Temporary Image
						  
							//----create resized image end
						}
						else
						{
							$copy = move_uploaded_file($_FILES['file']['tmp_name'], "$idir" . $nameoffile);   // Move Image From Temporary Location To Permanent Location
						}

						//============= RESIZE IMAGE CODE END =============

						imagedestroy($simg);   // Destroying The Temporary Image
						imagedestroy($dimg);   // Destroying The Other Temporary Image

						// Delete image if thumb doesn't exist
						if ((file_exists("$absolute_path_images/$nameoffile")) && (!file_exists("$absolute_path_thumbs/$nameoffile")))
						{
							unlink($idir.$nameoffile);
							$message = '<span style="color: orange"> » '.$lang_uploadimg['Unable to upload'].'</span>';
						}
						// Delete thumb if image doesn't exist
						else if ((file_exists("$absolute_path_thumbs/$nameoffile")) && (!file_exists("$absolute_path_images/$nameoffile")))
						{
							unlink($tdir.$nameoffile);
							$message = '<span style="color: orange"> » '.$lang_uploadimg['Unable to upload'].'</span>';
						}
						// If both the image and thumb exist
						else if ((file_exists("$absolute_path_images/$nameoffile")) && (file_exists("$absolute_path_thumbs/$nameoffile")))
						{
							// Update 'upload usage' and 'upload count'
							$db->query('UPDATE '.$db->prefix.'users SET upload_usage=upload_usage+'.intval(filesize("$absolute_path_images/$nameoffile")).', upload_count=upload_count+1 WHERE id='.$pun_user['id']) or error('Unable to update upload usage', __FILE__, __LINE__, $db->error());

							// Get image width and height
							$fdim = getimagesize("$absolute_path_images/$nameoffile");
							$fwidth = $fdim[0];
							$fheight = $fdim[1];

							// Get image type
							$fext = array_pop(explode('.', $nameoffile));
							$ftype = GetExt($fext);

							// Update 'uploadimg' table
							$db->query('INSERT INTO '.$db->prefix."uploadimg (filename, user_id, date, size, width, height, type) VALUES('".$db->escape($nameoffile)."', ".$pun_user['id'].", ".time().", ".intval(filesize("$absolute_path_images/$nameoffile")).", ".intval($fwidth).", ".intval($fheight).", '".$db->escape($ftype)."')") or error('Unable to add image info into uploadimg table', __FILE__, __LINE__, $db->error());

							// EZBBC stuff
							$upload_ok = true;
							//adding file to the uploaded img array
							array_unshift($img_list, $def_file_name);
							//adding file date to the uploaded img dates array
							$img_list_dates[$def_file_name] = time();

							$img_count++;
						}
						// If nothing exists
						else
						{
							$message = '<span style="color: orange"> » '.$lang_uploadimg['Unable to upload'].'</span>';
						}
					}
					else
					{
						$message = '<span style="color: orange"> » '.$lang_uploadimg['Unable to upload'].'</span>';
					}



//=========================================================================================
//                                   UPLOADIMG CODE END
//=========================================================================================
				}
			}
			else
			{
				$message = '<span style="color: orange"> » '.$lang_uploadimg_post['Upload folder not writable'].'</span>';
			}
		}

		//Listing of the images files if feature enabled
		if ($ezbbc_config['img_list'] == 'img_list')
		{
			//$folder_path = $path.'/'.$pun_user['id']; // [koos edit]
			$folder_path = $path; // [koos edit]
			for($i=0;$i<$img_count;$i++)
			{
				preg_match('@^([0-9]+)_(.*)$@', $img_list[$i], $matches);
				//$timestamp = $matches[1];
				$dienr = $matches[1]; // [koos edit]
				$name = $matches[2];
				//$date = date($lang_uploadimg_post['Date format'], $timestamp);
				$date = format_time($img_list_dates[$img_list[$i]], 0);

				$img_path = $folder_path.$img_list[$i];
				list($width, $height) = @getimagesize($img_path);
				$width = $width + 20;
				$height = $height + 20;

				if ($dienr == $pun_user['id'] && in_array($pun_user['g_title'], $Allow_Delete))
					$delete_part = ' <a href="'.$_SERVER['SCRIPT_NAME'].'?textarea_name='.$textarea_name.'&amp;action=remove&amp;fname='.urlencode($img_list[$i]).'" onclick="return window.confirm(\''.$lang_uploadimg_post['Delete file confirm'].'\')" title="'.$lang_uploadimg['Delete cap'].'"><img src="style/admin/listing/img-del.png" alt="'.$lang_uploadimg['Delete cap'].'" /></a>';
				else
					$delete_part = '';

				$img_list_display[]= '<li><a href="'.$img_path.'" onclick="window.open(this.href, \'Preview\', \'height='.$height.', width='.$width.', top=50, left=50, toolbar=no, menubar=no, location=no, resizable=yes, scrollbars=no, status=no\'); return false;" title="'.$lang_uploadimg_post['Display'].'"><img src="style/admin/listing/img.png" alt="'.$lang_uploadimg_post['Display'].'" /></a>'.$delete_part.' <a href="#" onclick="document.imageform.url.value = \''.$img_path.'\'; document.imageform.alt.focus(); return false;" title="'.$lang_uploadimg_post['Add'].'"><img src="style/admin/listing/img-add.png" alt="'.$lang_uploadimg_post['Add'].'" /></a> '.$date.' - <strong>'.$name.'</strong></li>';
			}
		}
}
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html>
<head>
	<title><?php echo $lang_uploadimg['Upload image'] ?></title>
	<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
	<link rel="stylesheet" type="text/css" href="<?php echo PUN_ROOT.'style/'.$pun_user['style'].'.css' ?>" />
	<script type="text/javascript">
	/* <![CDATA[ */
	// Function to make visible the images list
	function imgVisibility() {
		var imageForm = document.getElementById('cimages');;
		if (imageForm.style.display == "block") {
			imageForm.style.display = "none";
		} else {
			imageForm.style.display = "block";
		}
	}
	function clearMessage() {
	        var amessage = document.getElementById("amessage");
	        amessage.style.display = "none";
	}
	        
	// Function to retrieve the selection in opener and add it to the right field    
	function getSelection() {
        var field  = window.opener.document.getElementsByName('<?php echo $textarea_name ?>')[0]; 
        var scroll = field.scrollTop;
        field.focus();
        /* get the selection */
        if (window.ActiveXObject) { //For IE
                var textRange = window.opener.document.selection.createRange();
                var currentSelection = textRange.text;
        } else { //For other browsers
                var startSelection   = field.value.substring(0, field.selectionStart);
                var currentSelection = field.value.substring(field.selectionStart, field.selectionEnd);
                var endSelection     = field.value.substring(field.selectionEnd);
        }
        /* Add the selection to the label field */
		document.imageform.alt.value = currentSelection;
		document.imageform.url.focus();
	}
	// Function to insert The linktags and selection in opener Window
	function insertImageTag() {
        var field  = window.opener.document.getElementsByName('<?php echo $textarea_name ?>')[0]; 
        var scroll = field.scrollTop;
        field.focus();
                
        /* === Part 1: get the selection === */
        if (window.ActiveXObject) { //For IE
                var textRange = window.opener.document.selection.createRange();
                var currentSelection = textRange.text;
        } else { //For other browsers
                var startSelection   = field.value.substring(0, field.selectionStart);
                var currentSelection = field.value.substring(field.selectionStart, field.selectionEnd);
                var endSelection     = field.value.substring(field.selectionEnd);
        }
		
        /* === Part 2: creating tagged element === */
		var startTag = endTag = '';
		var alt = document.imageform.alt.value;
		var url = document.imageform.url.value;
		var testurl = url.toLowerCase();
				if (alt != '') { //A label has been entered
       				if (testurl.indexOf('http://') == 0 || testurl.indexOf('https://') == 0 || testurl.indexOf('ftp://') == 0) {
       				        startTag = '[img=' + alt + ']';
					currentSelection = url;
					endTag = '[/img]';
       				} else {
       				        alert("<?php echo $lang_uploadimg_post['Invalid url'] ?>");
					document.imageform.url.focus();
                                        return false;
       				}
       			} else { //No alt text entered
       				if (testurl.indexOf('http://') == 0 || testurl.indexOf('https://') == 0 || testurl.indexOf('ftp://') == 0) {
       				        startTag = '[img]';
					currentSelection = url;
                                        endTag = '[/img]';
       				} else {
       				        alert("<?php echo $lang_uploadimg_post['Invalid url'] ?>");
                                        document.imageform.url.focus();
                                        return false;
       				}
       			}
		
		/* === Part 3: adding what was produced to the opener === */
        if (window.ActiveXObject) { //For IE
                textRange.text = startTag + currentSelection + endTag;   
        } else { //For other browsers
                field.value = startSelection + startTag + currentSelection + endTag + endSelection;
                field.focus();
        } 

        field.scrollTop = scroll;
		self.close();		
	}
	/* ]]> */
	</script>
</head>
<body onload="getSelection(); setTimeout('clearMessage()', 4000);">
	<div id="punwrap">
		<div id="punuploadimg" class="pun">
		<div class="blockform">
		<div class="box">
		<div id="brdwelcome" class="inbox">
			<div id="brdmain">
				<div id="ezbbcimage">
					<form name="imageform" method="post" action="<?php echo $_SERVER['SCRIPT_NAME'].'?textarea_name='.$textarea_name ?>" enctype="multipart/form-data">
					<input type="hidden" name="alt" value="" />
					<p>
					<label class="required"><strong><?php echo $lang_uploadimg_post['Ask url img'] ?> <span><?php echo $lang_common['Required'] ?></span></strong><br />
					<input type="text" name="url" size="55" value="<?php if ($upload_ok) echo $file_path; ?>" /></label>
					</p>
                    <?php if ($ezbbc_config['img_upload'] == 'img_upload' && !$pun_user['is_guest'] && ($usage_perc < 100)): ?>
						<p>
						<?php echo $lang_uploadimg_post['Upload image file'] ?><?php echo $message ?><br />
						<input type="hidden" name="MAX_FILE_SIZE" value="<?php echo ($ezbbc_max_img_size*1024) ?>" />
						<input type="file" name="file" size="35" />
						<input type="submit" name="subfile" value="<?php echo $lang_uploadimg_post['Submit'] ?>" /><br />
<?php

// Determine usage start (refresh)
$result = $db->query('SELECT upload_usage FROM '.$db->prefix.'users WHERE id='.$pun_user['id'].'') or error('Unable to fetch upload usage', __FILE__, __LINE__, $db->error());
$user_data = $db->fetch_assoc($result);
$upload_usage = $user_data['upload_usage']/1024;

if (!empty($usage_max))
	$usage_perc = round(((($upload_usage / $usage_max)*100)),0);
else
	$usage_perc = 0;
// Determine usage end (refresh)

//echo $lang_uploadimg_post['Allowed extension display'].implode(',',$allowed_ext).' - '.$lang_uploadimg_post['Max size'].$ezbbc_max_img_size.$lang_uploadimg_post['Kb'];

$allowed_types = array();
if ($allow_jpg_uploads)
	$allowed_types[] = 'JPEG';
if ($allow_png_uploads)
	$allowed_types[] = 'PNG';
if ($allow_gif_uploads)
	$allowed_types[] = 'GIF';

if (empty($allowed_types))
	$allowed_types[] = 'None';

$upload_message = $lang_uploadimg_post['Allowed file types display'].implode(',',$allowed_types);

if ($size_limit == 'yes')
	$upload_message = $upload_message.' - '.$lang_uploadimg_post['Max size'].$limit_size.$lang_uploadimg_post['Kb'];

echo $upload_message;


?>
						</p>
					<?php endif; ?>
					<?php if ($ezbbc_config['img_upload'] == 'img_upload' && !$pun_user['is_guest']): ?>
				        <p>
				        <?php echo $lang_uploadimg_post['Already uploaded'].'<strong>'.$img_count.'</strong>' ?>
				        <?php if (!empty($usage_max)) echo '- '.$lang_uploadimg['Your usage'].' '.$usage_perc.'% of '.($usage_max/1024).'MB' ?><br />
				        </p>
                                <?php endif; ?>
                                <?php if ($ezbbc_config['img_upload'] == 'img_upload' && $ezbbc_config['img_list'] == 'img_list' && count($img_list) > 0): ?>
                                        <p>
					<a href="#" onclick="imgVisibility(); return false;"><?php echo $lang_uploadimg_post['My images'] ?></a>
					<?php echo $action_message ?>
					</p>
					<ul style="display: none; max-height: 100px; overflow: auto; border-bottom: grey 1px solid; border-top: grey 1px solid;" id="cimages">
					<?php 
					foreach($img_list_display as $img_item) {
					        echo $img_item;
					}
					?>
					</ul>
				<?php endif; ?>	
					<p class="buttons"><input type="button" value="<?php echo $lang_uploadimg_post['OK'] ?>" onclick="insertImageTag()" /> <input type="button" value="<?php echo $lang_uploadimg_post['Cancel'] ?>" onclick="self.close()" /></p>
                                
					</form>
				</div>
			</div>
		</div>
		</div>
		</div>
		</div>
	</div>
</body>
</html>
